#ifndef _DEFINES_
#define _DEFINES_

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <GL/glut.h>
#include <GL/glx.h>
#include <sys/timeb.h>

#define INIT_W 640
#define INIT_H 640
#define SIMINIT_W 640
#define SIMINIT_H 512
#define BOTINIT_W 640
#define BOTINIT_H 128
#define PI 3.141592654

#define NUMOBJS 4
#define NUMSHIPS 8

#define MAXLINE_READ 384

// Higher this goes, the slower the camera will transition between
// objects and views
#define TRANSITION_FACTOR 1.0

/* Image type - contains height, width, and data */
struct Image { 
    unsigned short sizeX;
    unsigned short sizeY;
    char *data;
};
typedef struct Image Image;

// parseraw.c
void read_raw_obj(char *, int);

void myinit(void);
void resize(GLsizei, GLsizei);
void key(unsigned char, int, int);
void readextobjs(void);
void drawextobj(int, GLfloat);
void cross_prod(int, int);
void init_ships(void);
void updatevalues(void);
void display(void);
void theidle(void);
void camerasmooth(void);
void fakestarfield(void);
void infoships(int);

// Borrowed code, I'll document later...
int ImageLoad(char *, Image *);
void LoadGLTextures(void);

void shuttle(float, float);
void ssd(float);
void tiefighter(float);
void tdrect(GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);

// External object struct
typedef struct external_objects{
	GLfloat *vx;
	GLfloat *vy;
	GLfloat *vz;
	int *colorid;
	int numvertices;
} external_objects;

// From pg.124 in OpenGL primer
typedef struct materialStruct{
	GLfloat ambient[4];	
	GLfloat diffuse[4];
	GLfloat specular[4];
	GLfloat shininess;
}materialStruct;

void setMaterials(materialStruct *,GLint);

extern materialStruct redlaser;			// 0
extern materialStruct bluesolarpanels;		// 1
extern materialStruct gengrey;			// 2
extern materialStruct bluengines;		// 3
extern materialStruct Brass;			// 4
extern materialStruct Bronze;			// 5
extern materialStruct Polished_Bronze;		// 6
extern materialStruct Chrome;			// 7
extern materialStruct Copper;			// 8
extern materialStruct Polished_Copper;		// 9
extern materialStruct Gold;			// 10
extern materialStruct Polished_Gold;		// 11
extern materialStruct Pewter;			// 12
extern materialStruct Silver;			// 13
extern materialStruct Polished_Silver;		// 14
extern materialStruct Emerald;			// 15
extern materialStruct Jade;			// 16
extern materialStruct Obsidian;			// 17
extern materialStruct Pearl;			// 18
extern materialStruct Ruby;			// 19
extern materialStruct Turquoise;		// 20
extern materialStruct Black_Plastic;		// 21
extern materialStruct Black_Rubber;		// 22
extern materialStruct whiteboy;			// 23

#endif
