#include "defines.h"

extern GLUquadricObj* gluObj;

// Creates a tie-fighter...the cheap ones you blow up easily...heh
void tiefighter(float g)
{
	// Set the material
	setMaterials(&gengrey, GL_FRONT_AND_BACK);

	// Make the pilot thingy
	gluSphere(gluObj, 0.05/g, 16, 16);

	// Make the pylons
	glPushMatrix();
		glTranslatef(-0.04/g, 0.0, 0.0);
		glRotatef(-90, 0.0, 1.0, 0.0);
		gluCylinder(gluObj, 0.01/g, 0.01/g, 0.08/g, 8, 8);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.04/g, 0.0, 0.0);
		glRotatef(90, 0.0, 1.0, 0.0);
		gluCylinder(gluObj, 0.01/g, 0.01/g, 0.08/g, 8, 8);
	glPopMatrix();

	// Make the smooth thingy on the outside of solar panels
	glPushMatrix();
		glTranslatef(0.11/g, 0.0, 0.0);
		glRotatef(90, 0.0, 1.0, 0.0);
		gluCylinder(gluObj, 0.03/g, 0.01/g, 0.01/g, 8, 8);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(-0.11/g, 0.0, 0.0);
		glRotatef(-90, 0.0, 1.0, 0.0);
		gluCylinder(gluObj, 0.03/g, 0.01/g, 0.01/g, 8, 8);
	glPopMatrix();

	// Make the smooth thingy on the inside of solar panels
	glPushMatrix();
		glTranslatef(0.09/g, 0.0, 0.0);
		glRotatef(90, 0.0, 1.0, 0.0);
		gluCylinder(gluObj, 0.01/g, 0.03/g, 0.01/g, 8, 8);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(-0.09/g, 0.0, 0.0);
		glRotatef(-90, 0.0, 1.0, 0.0);
		gluCylinder(gluObj, 0.01/g, 0.03/g, 0.01/g, 8, 8);
	glPopMatrix();

	// Make the solar panels
	setMaterials(&bluesolarpanels, GL_FRONT_AND_BACK);
	tdrect(0.1/g, 0.1/g, 0.1/g, 0.11/g, -0.1/g, -0.1/g);	// Left
	tdrect(-0.1/g, 0.1/g, 0.1/g, -0.11/g, -0.1/g, -0.1/g);	// Right

	// Make the laser thingies on the pilot module
	glPushMatrix();
		glTranslatef(0.0, 0.0, 0.05/g);
		glRotatef(45, 1.0, 0.0, 0.0);
		setMaterials(&redlaser, GL_FRONT_AND_BACK);
		gluSphere(gluObj, 0.005/g, 4, 4);
		setMaterials(&gengrey, GL_FRONT_AND_BACK);
	glPopMatrix();
}

// Generic 3D Rectangle
// starting coords, ending coords, color
void tdrect(GLfloat x1, GLfloat y1, GLfloat z1, GLfloat x2, GLfloat y2, GLfloat z2)
{
	// Back face
	glBegin(GL_POLYGON);
		glNormal3f(0.0, 0.0, 1.0);
		glVertex3f(x1, y1, z2);
		glVertex3f(x1, y2, z2);
		glVertex3f(x2, y2, z2);
		glVertex3f(x2, y1, z2);
	glEnd();

	// Left face
	glBegin(GL_POLYGON);
		glNormal3f(-1.0, 0.0, 0.0);
		glVertex3f(x1, y1, z1);
		glVertex3f(x1, y2, z1);
		glVertex3f(x1, y2, z2);
		glVertex3f(x1, y1, z2);
	glEnd();

	// Top face
	glBegin(GL_POLYGON);
		glNormal3f(0.0, 1.0, 0.0);
		glVertex3f(x1, y2, z2);
		glVertex3f(x1, y2, z1);
		glVertex3f(x2, y2, z1);
		glVertex3f(x2, y2, z2);
	glEnd();

	// Right face
	glBegin(GL_POLYGON);
		glNormal3f(1.0, 0.0, 0.0);
		glVertex3f(x2, y2, z1);
		glVertex3f(x2, y1, z1);
		glVertex3f(x2, y1, z2);
		glVertex3f(x2, y2, z2);
	glEnd();

	// Bottom face
	glBegin(GL_POLYGON);
		glNormal3f(0.0, -1.0, 0.0);
		glVertex3f(x2, y1, z1);
		glVertex3f(x1, y1, z1);
		glVertex3f(x1, y1, z2);
		glVertex3f(x2, y1, z2);
	glEnd();

	// Front face
	glBegin(GL_POLYGON);
		glNormal3f(0.0, 0.0, -1.0);
		glVertex3f(x1, y2, z1);
		glVertex3f(x1, y1, z1);
		glVertex3f(x2, y1, z1);
		glVertex3f(x2, y2, z1);
	glEnd();
}
